/*	This program's purpose is to allow a player to buy minerals.  The prices should be high
	and somewhat restrictive. */

/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
++																				++
++	Version 1.0																	++
++																				++
++	Updates:	June 9, 2000		Program inseption at 3:57 pm				++
++																				++
++				July 17, 2000		Added Addon support							++
++																				++
++				July 18, 2000		fixed Savefile not saving to the right		++
++										directory								++
++																				++
++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/

//------------Begin Inclusions and Definitions Here-----------------

#include <planets.h>
#include <stdlib.h>
#include <string.h>

//--------------------Begin Function Prototypes---------------------

char* GenerateFileName(char* root, char* path);
int LoadPlanets(char* filename);
int Start();
int CheckFCs(int i);
void ProcessCommand(char* command, int i);
void BuyDuranium(int num, int i);
void BuyTritanium(int num, int i);
void BuyMolybdenum(int num, int i);
void SaveFile(char* filename);

//------------------------Global Variables--------------------------

VPlanet Planets[500];	// Create an array of VPlanet objects

//-----------------Begin Program Execution Here---------------------

//********************************************************************************

void main(int argc, char* argv[])
{	
	char* filename = new char[40];
	if (argc > 0) 
		filename = GenerateFileName(argv[0], argv[1]);

	LoadPlanets(filename);	// Load the Pdata.hst file into memory

	Start();		// Start the exchange function(s)

	SaveFile(filename);
}

//********************************************************************************

char* GenerateFileName(char* root, char* path)
{
	char* file = new char[40];
	int length;

	//=========================
	//--------Begin Loop-------
	//=========================
	for (int i=0; i<30; i++)
	{
		if (root[i] == '.')
		{
			length = i;
			break;
		} // end if
		else
			file[i] = root[i];
	} // end for

	//=========================
	//-------New Loop----------
	//=========================

	length = length - 6;


	for(int j = 0; j<10; j++)
	{
		int pos = length + j;
		file[pos] = NULL;
	}

	strcat(file, path); 
	strcat(file, "\\pdata.hst");
	
	return file;
}

//********************************************************************************
int LoadPlanets(char* filename)
{
	cout << "Reading planet indices" << endl;
	for(int i=0; i<500; i++)
	{
		Planets[i].readFile(i, filename);
	}	// end for
	return 1;
}	// end LoadPlanets

//********************************************************************************

int Start()
{
	for(int i=0; i<500; i++)
	{
		int found = CheckFCs(i);
		if(found)
		{
			cout << "Found Purchase Request - Processing Command" << endl;
			ProcessCommand(Planets[i].getFC(), i);
			found = 0;
		}		// end if
	}		// end for
	return 1;
}		// end Start()

//********************************************************************************

int CheckFCs(int i)
{
	char* FC = Planets[i].getFC();

	//**********************
	//******PARSE FC********
	//**********************
	char com[3];

	for(int j=0; j<3; j++)
	{
		com[j] = *FC;
		FC++;
	}

	char commType[2];
	commType[0] = com[0];
	commType[1] = com[1];

	char* s = new char;

	*s = com[2];

	int num = atoi(s);

	//******DONE PARSING******

	if (commType[0] == 'B')		// if the first character of the FC is 'B'...
	{
		switch(commType[1])		// if the second character is...
		{
		case 'D':				// ...D, we're good, return 1
			return 1;
			break;
		case 'T':				// ...T, "
			return 1;
			break;
		case 'M':				// ...M, "
			return 1;
			break;
		default:				// ... anything else, not good, return 0
			return 0;
		}	// end switch
	}	// end if
	else
		return 0;
}

//********************************************************************************

void ProcessCommand(char* command, int i)
{
	char com[3];

	for(int j=0; j<3; j++)
	{
		com[j] = *command;
		command++;
	}

	char commType[2];
	commType[0] = com[0];
	commType[1] = com[1];

	char* s = new char;

	*s = com[2];

	int num = atoi(s);
		
	switch(commType[1])
	{
	case 'D':
		BuyDuranium(num, i);
		if(*s == 83)
			return;						// Jupiter is in use...
		break;
	case 'T':
		BuyTritanium(num, i);
		break;
	case 'M':
		BuyMolybdenum(num, i);
		break;
	}
}

//********************************************************************************

void BuyDuranium(int num, int i)
{
	num *= 100;

	if(Planets[i].getMegacredits() >= (num * 4))
	{
		cout << "Found Money..." << endl << "Selling Minerals...";
		cout << "Current Money = " << Planets[i].getMegacredits() << endl;
		Planets[i].setMegacredits((Planets[i].getMegacredits()) - (num * 4));
		Planets[i].setMinedD((Planets[i].getMinedD()) + num);
		cout << "New Money = " << Planets[i].getMegacredits() << endl;
	}	// end if
	else
		cout << "Not Enough Money" << endl;
}

//********************************************************************************

void BuyTritanium(int num, int i)
{
	num *= 100;

	if(Planets[i].getMegacredits() >= (num * 4))
	{
		cout << "Found Money..." << endl << "Selling Minerals...";
		cout << "Current Money = " << Planets[i].getMegacredits() << endl;
		Planets[i].setMegacredits((Planets[i].getMegacredits()) - (num * 4));
		Planets[i].setMinedT((Planets[i].getMinedT()) + num);
		cout << "New Money = " << Planets[i].getMegacredits() << endl;
	}	// end if
}

//********************************************************************************

void BuyMolybdenum(int num, int i)
{
	num *= 100;

	if(Planets[i].getMegacredits() >= (num * 4))
	{
		cout << "Found Money..." << endl << "Selling Minerals...";
		cout << "Current Money = " << Planets[i].getMegacredits() << endl;
		Planets[i].setMegacredits((Planets[i].getMegacredits()) - (num * 4));
		Planets[i].setMinedM((Planets[i].getMinedM()) + num);
		cout << "New Money = " << Planets[i].getMegacredits() << endl;
	}	// end if
}
//********************************************************************************

void SaveFile(char* filename)
{
	for(int i=0; i<500; i++)
	{
		Planets[i].writeFile(i, filename);
	}
}