/* This program creates a randomly generated map for VGA Planets.
   I have designed this program to be fully automated.  It loads itself,
   loads the xyplan.dat file, rondomizes the values, and returns a new file */

#include <fstream.h>								// for the file input/output functions
#include <stdlib.h>
#include <time.h>

class TPlanet										// a class to hold the planet coordinates
{
public:
	short x_cor, y_cor, owner;						// the three features of each planet
	int FileRead(int pos)							// loads a single entry in the XYPLAN.DAT	
	{												// file into memory
		ifstream infile;							// create instance of ifstream class
		infile.open("XYPLAN.DAT", ios::binary);		// open XYPLAN.DAT
		infile.seekg( pos*sizeof(TPlanet) );		// point to the pos entry
		infile.read((char*)this, sizeof(*this) );	// read entry
		return 1;									// return true; it worked
	}
	int FileWrite(int index)									// Saves the newly created file to
	{												// NewMap.dat
		ofstream outfile;							// create instance of ofstream class
		outfile.open("NewMap.dat", ios::binary | ios::app);	// open file
		outfile.write( (char*)this, sizeof(*this) );	// write it
		return 1;									// it worked
	}
	int RandY(int n)				// Randomizes the value (y only: Winplan requires that all 
	{								// x values add up to a certain number.  To make sure that
									// they do, I don't change x at all.)
		srand(n * (unsigned)time(NULL));		// seed the generator
		y_cor = (rand() % 2000) + 1000;			// randomize y
		if(y_cor > 3000)			// if y is off the map, subtract 1000. This makes the lower
			y_cor =- 1000;			// end of the map a little more dense than the top. Oh well.
		return 1;									// it worked.
	}
	void clean()					// empties the file.  Just to make sure that there are no
	{								// trash entries
		y_cor = 0;					// y = 0
		owner = 0;					// there is no owner
	}
};	// end TPlanet class



//*********************************************************

void main()							// Enter main()
{
	TPlanet planet;
	cout << "Welcome!  Let's Get Started!";
	for(int planet_num = 0; planet_num < 501; ++planet_num)	// a for loop to load the data
	{
		planet.FileRead(planet_num);	// load the next item (it starts at one and goes up)
		planet.RandY(planet_num);		// randomize the y coordinate
		planet.FileWrite(planet_num);    	// write the new coordinate to the file
		cout << "Planet Number " << planet_num << " Edited" << endl;	// verify
		planet.clean();				// clear the object.  If you don't the x value will not
	};	// end for loop					// move
	return;
}	// end program
