//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Main.h"
#include <string.h>
#include <stdlib.h>
#include <dir.h>
#include <hullspecs.h>
#include <truehull.h>
#include <torpspecs.h>
#include "Unit1.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"

TFirstScreen *FirstScreen;
VHullSpec Hull;
VTrueHull Truehull;
int NodeIndex;
//---------------------------------------------------------------------------
__fastcall TFirstScreen::TFirstScreen(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TFirstScreen::AuxTypeClick(TObject *Sender)
{
    if(AuxType->ItemIndex)
    {
        FighterBaysBox->Enabled = false;
        NumFight->Enabled = false;
        TubeBox->Enabled = true;
        TubeMax->Enabled = true;
    }
    if(!AuxType->ItemIndex)
    {
        TubeBox->Enabled = false;
        TubeMax->Enabled = false;
        FighterBaysBox->Enabled = true;
        NumFight->Enabled = true;
    }
}
//---------------------------------------------------------------------------
// There needs to be something that will load the tree view here
//---------------------------------------------------------------------------

void __fastcall TFirstScreen::LoadHullData(TObject *Sender, int filenum)
{
    Hull.readFile(filenum);             // open the first entry
    Name->Text = Hull.GetName();        // set ship name
    char string[4];                     // string to hold temp values

    // Load the data.
    FuelTank->Text = itoa(Hull.GetTankSize(), string, 10);
    NumEngine->Text = itoa(Hull.GetNumberOfEngines(), string, 10);
    NumBeams->Text = itoa(Hull.GetMaxBeams(), string, 10);
    TriBox->Text = itoa(Hull.GetTritanium(), string, 10);
    DurBox->Text = itoa(Hull.GetDuranium(), string, 10);
    MolyBox->Text = itoa(Hull.GetMolybdenum(), string, 10);
    CrewSize->Text = itoa(Hull.GetCrewSize(), string, 10);
    MassBox->Text = itoa(Hull.GetMass(), string, 10);
    TechBox->Text = itoa(Hull.GetTechLevel(), string, 10);
    CargoBox->Text = itoa(Hull.GetCargoSpace(), string, 10);
    FighterBaysBox->Text = itoa(Hull.GetNumberOfFighterBays(), string, 10);
    TubeBox->Text = itoa(Hull.GetMaxTorpedoeL(), string, 10);
    CostBox->Text = itoa(Hull.GetCost(), string, 10);
    if(Hull.GetNumberOfFighterBays() > 0)
        AuxType->ItemIndex = 0;
    if(Hull.GetMaxTorpedoeL() > 0)
        AuxType->ItemIndex = 1;
    if(Hull.GetNumberOfFighterBays() == 0 && Hull.GetMaxTorpedoeL() == 0)
    {
        NumFight->Enabled = false;
        TubeMax->Enabled = false;
        FighterBaysBox->Enabled = false;
        TubeBox->Enabled = false;
    }
    PictureBox->Text = itoa(Hull.GetPicture(), string, 10);

    // Step through and check Truehull.dat for other owners

    // First, clear old check data
    FedCheck->Checked = false;
    LizardCheck->Checked = false;
    BirdCheck->Checked = false;
    FascistCheck->Checked = false;
    PrivCheck->Checked = false;
    CyborgCheck->Checked = false;
    CrystalCheck->Checked = false;
    EmpireCheck->Checked = false;
    BotCheck->Checked = false;
    RebelCheck->Checked = false;
    ColoniesCheck->Checked = false;

    // Now check.
    /***************************************************************************
    ** NOTE: This section does not work correctly.  Some of the ships display **
    ** as belonging to the Feds and the Privs.  I don't know what is wrong yet**
    ***************************************************************************/

    int shipnum = 1 + filenum;
    for(int i=0; i<12; i++)
    {
        Truehull.readFile(i);
        for(int j=0; j<20; j++)
        {
            if(Truehull.getShipx(j) == shipnum)
                CheckTrueHullBox(Sender, i);
        } // end for
    } // end for
}  // end LoadDat

// -------------------------------------------------------------------------
void __fastcall TFirstScreen::CheckTrueHullBox(TObject* Sender, int raceNum)
{
    switch(raceNum)
    {
        case 0:
            FedCheck->Checked = true;
            break;
        case 1:
            LizardCheck->Checked = true;
            break;
        case 2:
            BirdCheck->Checked = true;
            break;
        case 3:
            FascistCheck->Checked = true;
            break;
        case 4:
            PrivCheck->Checked = true;
            break;
        case 5:
            CyborgCheck->Checked = true;
            break;
        case 6:
            CrystalCheck->Checked = true;
            break;
        case 7:
            EmpireCheck->Checked = true;
            break;
        case 8:
            BotCheck->Checked = true;
            break;
        case 9:
            RebelCheck->Checked = true;
            break;
        case 10:
            ColoniesCheck->Checked = true;
            break;
    };  // end switch
}

// -------------------------------------------------------------------------

void __fastcall TFirstScreen::LoadTreeView(TObject *Sender)
{
    TreeList->Items->Clear();       // Clear all of the old data.  This keeps it
                                    // from loading the file twice.
    for (int i=0; i<105; i++)       // Start for loop which steps through each
    {                               // entry and adds it's name to the tree list
        Hull.readFile(i);           // Load an entry into the VHullSpec object
        TreeList->Items->Add(TreeList->Selected, Hull.GetName());   // Add a node
    }                               // to the tree list.
}
//--------------------------------------------------------------------------

void __fastcall TFirstScreen::TreeListChange(TObject *Sender,
      TTreeNode *Node)
{
   LoadHullData(Sender, Node->Index);  // Load the data from HULLSPEC.Dat
   NodeIndex = Node->Index;            // Set the NodeIndex variable to the
}
//---------------------------------------------------------------------------

void __fastcall TFirstScreen::FSaveClick(TObject *Sender)
{
    HullSave(Sender);
}
//---------------------------------------------------------------------------

void __fastcall TFirstScreen::FExitClick(TObject *Sender)
{
    Close();                       // Close program
}
//---------------------------------------------------------------------------

void __fastcall TFirstScreen::SpeedButton1Click(TObject *Sender)
{
    FSaveClick(FirstScreen);        // Save changes
}
//---------------------------------------------------------------------------

void __fastcall TFirstScreen::HullSave(TObject* Sender)
{
    // Set the new name
    int Size = Name->GetTextLen();
    Size++;
    char* Buffer = new char[Size];
    Name->GetTextBuf(Buffer, Size);
    Hull.SetName(Buffer);
    FuelTank->GetTextBuf(Buffer, 4);        // Get Fuel Tank Buffer
    Hull.SetTankSize(atoi(Buffer));         // Set New Size
    NumEngine->GetTextBuf(Buffer, 4);       // Get Engine Number Buffer
    Hull.SetNumberOfEngines(atoi(Buffer));  // Set New Size
    NumBeams->GetTextBuf(Buffer, 4);
    Hull.SetMaxBeams(atoi(Buffer));
    TriBox->GetTextBuf(Buffer, 4);
    Hull.SetTritanium(atoi(Buffer));
    DurBox->GetTextBuf(Buffer, 4);
    Hull.SetDuranium(atoi(Buffer));
    MolyBox->GetTextBuf(Buffer, 4);
    Hull.SetMoybdenum(atoi(Buffer));        // typo: should be SetMolybdenum()
    CrewSize->GetTextBuf(Buffer, 4);
    Hull.SetCrewSize(atoi(Buffer));
    MassBox->GetTextBuf(Buffer, 4);
    Hull.SetMass(atoi(Buffer));
    TechBox->GetTextBuf(Buffer, 4);
    Hull.SetTechLevel(atoi(Buffer));
    CargoBox->GetTextBuf(Buffer, 4);
    Hull.SetCargo(atoi(Buffer));
    FighterBaysBox->GetTextBuf(Buffer, 4);
    Hull.SetNumberOfBays(atoi(Buffer));
    TubeBox->GetTextBuf(Buffer, 4);
    Hull.SetMaxTorpedoeL(atoi(Buffer));
    CostBox->GetTextBuf(Buffer, 4);
    Hull.SetCost(atoi(Buffer));
    PictureBox->GetTextBuf(Buffer, 4);
    Hull.SetPicture(atoi(Buffer));

    Hull.writeFile(NodeIndex);      // Save Changes
}
//---------------------------------------------------------------------------
void __fastcall TFirstScreen::FormActivate(TObject *Sender)
{
    LoadTreeView(Sender);    
}
//---------------------------------------------------------------------------

void __fastcall TFirstScreen::HelpAboutClick(TObject *Sender)
{
    AboutBox->Show();    
}
//---------------------------------------------------------------------------

