/*	This file contains the VShip class and is structured like Planets.h */

#ifndef FSTREAM_H
#define FSTREAM_H

#include <fstream.h>
#endif

#ifndef SHIPS_H
#define SHIPS_H

typedef short word;
typedef long dword;

class VShip
{
private:
	word ship_id;
	word player_id;
	char FC[3];
	word warp_factor;
	word dtow_x;							// 'D'istance 'TO' 'W'aypoint on X
	word dtow_y;
	word x_pos;
	word y_pos;
	word engine_type;
	word hull_type;
	word beam_type;
	word beam_num;
	word num_fighter_bays;
	word torpedoeL_type;
	word num_torf;
	word num_torpedoeL;
	word mission;
	word primary_enemy;
	word tow_id;
	word damage;
	word crew;
	word colonists;
	char name[20];
	word neutronium;
	word tritanium;
	word duranium;
	word molybdenum;
	word supplies;
	word unload_cargo[7];
	word transfer_to_enemy[7];
	word intercept_id;
	word mc;
public:

	// the get list
	short GetShipID() { return ship_id; }
	short GetPlayerID() { return player_id; }
	char* GetFC()
	{	
		char* FCode = FC;  
		return FCode; 
	}
	short GetWarpFactor() { return warp_factor; }
	short GetDistanceToWaypointX() { return dtow_x; }
	short GetDistanceToWaypointY() { return dtow_y; }
	short GetXPosition() { return x_pos; }
	short GetYPosition() { return y_pos; }
	short GetEngineType() { return engine_type; }
	short GetHullType() { return hull_type; }
	short GetBeamType() {return beam_type; }
	short GetBeamNum() { return beam_num; }
	short GetNumberFighterBays() { return num_fighter_bays; }
	short GetTorpedoeLType() { return torpedoeL_type; }
	short GetNumberTorpedoes() { return num_torf; }
	short GetNumberFighters() { return num_torf; }
	short GetNumberTorpedoeL() { return num_torpedoeL; }
	short GetMission() { return mission;}
	short GetPrimaryEnemy() { return primary_enemy; }
	short GetTowID() { return tow_id; }
	short GetDamage() { return damage; }
	short GetCrew() { return crew; }
	short GetColonists() { return colonists; }
	char* GetName()
	{
		char* PName = name;
		return PName;
	}
	short GetNeutronium() { return neutronium; }
	short GetTritanium() { return tritanium; }
	short GetDuranium() { return duranium; }
	short GetMolybdenum() { return molybdenum; }
	short GetSupplies() { return supplies; }
	short GetCargoShip(int index_num) { return unload_cargo[index_num]; }
	short GetCargoTransfer(int index_num) { return transfer_to_enemy[index_num]; }
	short GetInterceptID() { return intercept_id; }
	short GetMegacredits() { return mc; }

	// The set list
	// NOTE: in all cases, 'nv' stands for 'new value' and is the new value for the variable
	void SetShipID(word nv) { ship_id = nv; }
	void SetPlayerID(word nv) { player_id = nv; }
	void SetFC(char* FCode) 
	{ 
		char* Code = FC;
		Code = FCode;
	}
	void SetWarpFactor(word nv) { warp_factor = nv; }
	void SetDistanceToWaypointX(word nv) { dtow_x = nv; }
	void SetDistanceToWaypointY(word nv) { dtow_y = nv; }
	void SetXPosition(word nv) { x_pos = nv; }
	void SetYPosition(word nv) { y_pos = nv; }
	void SetEngineType(word nv) { engine_type = nv; }
	void SetHullType(word nv) { hull_type = nv; }
	void SetBeamType(word nv) { beam_type = nv; }
	void SetBeamNum(word nv) { beam_num = nv; }
	void SetNumberFighterBays(word nv) { num_fighter_bays = nv; }
	void SetTorpedoeLType(word nv) { torpedoeL_type = nv; }
	void SetNumberTorpedoes(word nv) { num_torf = nv; }
	void SetNumberFighters(word nv) { num_torf = nv; }
	void SetNumberTorpedoeL(word nv) { num_torpedoeL = nv; }
	void SetMission(word nv) { mission = nv; }
	void SetPrimaryEnemy(word nv) { primary_enemy = nv; }
	void SetTowID(word nv) { tow_id = nv; }
	void SetDamage(word nv) { damage = nv; }
	void SetCrew(word nv) { crew = nv; }
	void SetColonists(word nv) {colonists = nv; }
	void SetName(char* NName) 
	{ 
		for(int i=0; i<20; i++)
		{
			name[i] = *NName;
			NName++;
		}
	}
	void SetNeutronium(word nv) { neutronium = nv; }
	void SetTritanium(word nv) { tritanium = nv; }
	void SetDuranium(word nv) { duranium = nv; }
	void SetMolybdennum(word nv) { molybdenum = nv; }
	void SetSupplies(word nv) { supplies = nv; }
	void SetCargoShip(short index_num, word nv) { unload_cargo[index_num] = nv; }
	void SetTransferToEnemy(short index_num, word nv) { transfer_to_enemy[index_num] = nv; }
	void SetInterceptID(word nv) { intercept_id = nv; }
	void SetMegacredits(word nv) { mc = nv; }

	//	The following functions are used to read and write that data from the SHIPx.dat files
	void readFile(int pos, char* file)
	{
		ifstream infile(file, ios::binary);
		infile.seekg((pos*sizeof(VShip))+4);
		infile.read((char*)this, sizeof(*this) );
	}

	void writeFile(int pos, char* file)
	{
		ofstream outfile(file, ios::binary);
		outfile.seekp((pos*sizeof(VShip))+4);
		outfile.write((char*)this, sizeof(*this));
	}
};

#endif

char* SHIP1 = "SHIP1.DAT";
char* SHIP2 = "SHIP2.DAT";
char* SHIP3 = "SHIP3,DAT";
char* SHIP4 = "SHIP4.DAT";
char* SHIP5 = "SHIP5.DAT";
char* SHIP6 = "SHIP6.DAT";
char* SHIP7 = "SHIP7.DAT";
char* SHIP9 = "SHIP9.DAT";
char* SHIP10 = "SHIP10.DAT";
char* SHIP11 = "SHIP11.DAT";